from django.conf.urls import url
from . import views

urlpatterns = [
    url(r'^$', views.MenuList, name = 'menu-list'),
    url(r'^add-menu/', views.AddMenu, name = 'add-menu'),
    url(r'^menu-list/', views.MenuList, name = 'menu-list'),
    url(r'^get-menu-details/', views.MenuDetails, name = 'get-menu-details'),   
	url(r'^set-permission/', views.SetPermission, name = 'add-category'), 
	url(r'^test-login/', views.TestLogin, name = 'test-login'),
	url(r'^set-login/(\d+)/', views.SetLogin, name = 'set-login'),
	url(r'^user-permission/', views.UserPermission, name = 'user-permission'),
	url(r'^client-permission/', views.ClientPermission, name = 'client-permission'),  
	url(r'^add-user/', views.AddUser, name = 'add-user'),
	url(r'^get-menu-list/', views.GetMenuList, name = 'get-menu-list'),
	url(r'^hor-menu/', views.HorizontalMenu, name = 'hor-menu'),
	
 ]