# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models

# Create your models here.
class RewriteMaster(models.Model):
	account = models.ForeignKey('userauth.ProfileDetails')
	reffering_domain = models.CharField(null=True,max_length=250)
	search_phrase = models.CharField(null=True,max_length=250)
	date_ordered = models.DateTimeField(null=True)

	class Meta:
		db_table = 'rewrite_master'

class AssosiatedCampaign(models.Model):
	rewrite_master = models.ForeignKey(RewriteMaster)
	campaign = models.ForeignKey('campaigns.CampaignDetails')		
	number_clickable = models.IntegerField(null=True)
	left_link_text = models.CharField(null=True,max_length=250)
	right_link_text = models.CharField(null=True,max_length=250)

	class Meta:
		db_table = 'assosiated_campaign'

class RewriteNumbers(models.Model):
	assosiated_campaign = models.ForeignKey(AssosiatedCampaign)
	number = models.CharField(max_length=15)
	rewrite_to = models.CharField(max_length=15)

	class Meta:
		db_table = 'rewrite_numbers'	