# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render,redirect
from django.http import HttpResponse
from campaigns.models import CampaignDetails
from rewrites.models import RewriteMaster,AssosiatedCampaign, RewriteNumbers
from userauth import views
from userauth.models import ProfileDetails
import datetime,collections,json

# Create your views here.

def RewriteAdd(request):
	datagrid = 'Add Rewrite'
	assocCamp = {}
	account_sid = request.session["sid"]
	account = ProfileDetails.objects.get(sid=account_sid)
	if request.method == "POST":
		
		search_phrase = ''
		
		if 'reffer_domain' in request.POST:
			reffer_domain = request.POST["reffer_domain"]
			if reffer_domain == '':
				reffer_domain = 'any'
			# print reffer_domain
		if 'search_phrase' in request.POST:
			search_phrase = request.POST["search_phrase"]
			# print search_phrase

		#Save Rewrite	
		rewrite_master = RewriteMaster()	
		rewrite_master.account = account
		rewrite_master.reffering_domain = reffer_domain
		rewrite_master.search_phrase = search_phrase
		if 'rewrite_id' in request.POST:
			rewrite_id = request.POST["rewrite_id"]
			rewrite_details = RewriteMaster.objects.filter(id=rewrite_id)
			for det in rewrite_details:
				rewrite_master.date_ordered = det.date_ordered
			associated_campaign = AssosiatedCampaign.objects.filter(rewrite_master_id = rewrite_id)
			for det_assocamp in associated_campaign:
				assocCamp[str(det_assocamp.campaign_id)] = det_assocamp.id
			# print(assocCamp)
			
		else:
			rewrite_master.date_ordered = datetime.datetime.now()

		rewrite_master.save()
		last_rewrite = RewriteMaster.objects.latest('id')
		#Save Assosiated Campaigns
		if 'rewrite_id' in request.POST:
			selected_campaigns1 = request.POST["jsrw"].split(',')
			selected_campaigns = list(set(selected_campaigns1))
			for campaign_id in selected_campaigns:
				if campaign_id in assocCamp:
					# print('present')
					# print(campaign_id)
					AssosiatedCampaign.objects.filter(id = assocCamp[campaign_id]).update(rewrite_master_id = last_rewrite)
				
				else:
					# print('not present')
					# print(campaign_id)
					assosiated_campaign = AssosiatedCampaign()
					campaign = CampaignDetails.objects.get(pid=campaign_id)
					assosiated_campaign.campaign = campaign
					assosiated_campaign.rewrite_master = rewrite_master
					assosiated_campaign.save()
					
		else:
			selected_campaigns1 = request.POST.getlist("selected_campaigns")
			selected_campaigns = list(set(selected_campaigns1))

			for campaign_id in selected_campaigns:
				assosiated_campaign = AssosiatedCampaign()
				campaign = CampaignDetails.objects.get(pid=campaign_id)
				assosiated_campaign.campaign = campaign
				assosiated_campaign.rewrite_master = rewrite_master
				assosiated_campaign.save()
			print "Assosiated camapaigs "+campaign.name+" Saved."
		

		if 'rewrite_id' in request.POST:
			rewrite_id = request.POST["rewrite_id"]
			RewriteNumbers.objects.filter(assosiated_campaign__rewrite_master__id=rewrite_id).delete()
			AssosiatedCampaign.objects.filter(rewrite_master_id = rewrite_id).delete()
			RewriteMaster.objects.filter(id=rewrite_id).delete()
			# RewriteMaster.objects.filter(id=rewrite_id).update(assosiated_campaign='some value')

			
			return redirect('/rewrites/view-rewrites/'+str(last_rewrite.id)+'/')


		return redirect('/rewrites/list')		

	if request.session.has_key('client_id'):
		account_id = request.session['client_id']
		# campaigns = CampaignDetails.objects.raw("select * from campaign_details join number_master on campaign_details.number_id = number_master.id where campaign_details.client_id = %s",[request.session["client_id"]])
		# campaigns = CampaignDetails.objects.filter(client_id=request.session["client_id"])
	elif request.session.has_key('agency_id'):
		account_id = request.session['agency_id']
		# campaigns = CampaignDetails.objects.raw("select * from campaign_details join number_master on campaign_details.number_id = number_master.id where campaign_details.agency_id = %s",[request.session["agency_id"]])	

	arr_asscamp = []
	assosiated_campaigns = AssosiatedCampaign.objects.filter(rewrite_master__account = account_id, campaign__status = 1)
	# print(assosiated_campaigns.query)
	for ass in assosiated_campaigns:
		arr_asscamp.append(ass.campaign_id)

	sql = "select A.pid, B.campaign_id from campaign_details A left join call_forward_settings B on A.pid = B.campaign_id where A.client_id = '"+str(account_id)+"' and A.status = 1"
	# print(sql)
	impropercampaign = CampaignDetails.objects.raw(sql)
	for impcamp in impropercampaign:
		if impcamp.campaign_id is None:
			# print(impcamp.pid)
			arr_asscamp.append(impcamp.pid)
	# available_campaigns = CampaignDetails.objects.raw("select A.pid, A.name, B.number from campaign_details A inner join number_master B on A.number_id = B.id where A.pid not in (select campaign_id from assosiated_campaign where rewrite_master_id = '"+str(rewrite_id)+"') and A.client_id='"+str(account_id)+"'")	
	available_campaigns = CampaignDetails.objects.filter(client_id = account_id, status = 1).exclude(pid__in=arr_asscamp)	
	# print(available_campaigns.query)
	return render(request,'create-rewrites.html',{'datagrid':datagrid,'campaigns':available_campaigns})

def RewriteList(request):
	datagrid = 'Javascript Rewrites'

	account_id = request.session["client_id"]
	uniqueid = request.session["uniqueid"]
	rewrites = RewriteMaster.objects.filter(account_id=account_id)
	print(uniqueid)
	script = '<script type="text/javascript"> unq_id = "'+str(uniqueid)+'";</script><script type="text/javascript" src="//app.callluge.com/cctsp/calltrack.js"></script>'
	return render(request,'list-rewrites.html',{'rewrites':rewrites,'datagrid':datagrid,'script':script})

def DeleteRewrite(request):
	rewrite_id = request.POST["rewrite_id"]
	RewriteNumbers.objects.filter(assosiated_campaign__rewrite_master__id=rewrite_id).delete()
	AssosiatedCampaign.objects.filter(rewrite_master_id = rewrite_id).delete()
	RewriteMaster.objects.filter(id=rewrite_id).delete()
	return HttpResponse('Deleted')

def RewriteCampaigns(request):
	ref_domain = search_phase = '' 
	arr_asscamp = []
	account_id = request.session["client_id"]
	rewrite_id = request.POST["rewrite_id"]
	rewrite_details = RewriteMaster.objects.filter(id=rewrite_id)
	for re_details in rewrite_details:
		ref_domain = re_details.reffering_domain
		search_phase = re_details.search_phrase

	assosiated_campaigns = AssosiatedCampaign.objects.filter(rewrite_master_id = rewrite_id, campaign__status = 1)
	# assosiated_campaigns = AssosiatedCampaign.objects.filter(rewrite_master__account = account_id)
	
	# for ass in assosiated_campaigns:
	# 	arr_asscamp.append(ass.campaign_id)

	assosiated_campaigns_account = AssosiatedCampaign.objects.filter(rewrite_master__account = account_id, campaign__status = 1)
	for ass_acc in assosiated_campaigns_account:
		arr_asscamp.append(ass_acc.campaign_id)
	# print(arr_asscamp)
	sql = "select A.pid, B.campaign_id from campaign_details A left join call_forward_settings B on A.pid = B.campaign_id where A.client_id = '"+str(account_id)+"' and A.status = 1"
	# print(sql)
	impropercampaign = CampaignDetails.objects.raw(sql)
	for impcamp in impropercampaign:
		if impcamp.campaign_id is None:
			# print(impcamp.pid)
			arr_asscamp.append(impcamp.pid)

	# print(arr_asscamp)
	# available_campaigns = CampaignDetails.objects.raw("select A.pid, A.name, B.number from campaign_details A inner join number_master B on A.number_id = B.id where A.pid not in (select campaign_id from assosiated_campaign where rewrite_master_id = '"+str(rewrite_id)+"') and A.client_id='"+str(account_id)+"'")	
	available_campaigns = CampaignDetails.objects.filter(client_id = account_id, status = 1).exclude(pid__in=arr_asscamp)	
	
	# print(available_campaigns.query)
	# print(assosiated_campaigns.query)
	
	return render(request,'campaign-details-rewrite.html',{'assosiated_campaigns':assosiated_campaigns,'available_campaigns':available_campaigns, 'rewrite_id': rewrite_id, 'ref_domain': ref_domain, 'search_phase': search_phase})


def ViewRewrites(request,key):
	datagrid = 'View Rewrites'
	account_id = request.session["client_id"]
	rewrite_details = RewriteMaster.objects.filter(id=key, account_id=account_id)
	if rewrite_details:		
		for re_details in rewrite_details:
			rewrite_name = re_details.reffering_domain
		assosiated_campaigns = AssosiatedCampaign.objects.filter(rewrite_master_id = key, campaign__status = 1)
		rewrite_numbers = RewriteNumbers.objects.filter(assosiated_campaign__rewrite_master__id=key, assosiated_campaign__campaign__status = 1)
		return render(request,'view-rewrites.html',{'assosiated_campaigns':assosiated_campaigns,'rewrite_numbers': rewrite_numbers, 'rewrite_id': key, 'rewrite_name': rewrite_name, 'datagrid': datagrid})
	else:
		return redirect('/rewrites/list/')

def AddRewriteNumber(request):
	# print request.POST
	assosiated_campaign_id = request.POST["assosiated_campaign_id"]
	assosiated_campaign = AssosiatedCampaign.objects.get(id=assosiated_campaign_id)
	number = request.POST["number"]
	rewrite_to = request.POST["rewrite_to"]
	
	#Save Rewrite Number
	rewrite_number = RewriteNumbers()
	rewrite_number.number = number
	rewrite_number.rewrite_to = rewrite_to
	rewrite_number.assosiated_campaign = assosiated_campaign
	rewrite_number.save()

	num_id = 'number_'+str(rewrite_number.id)
	tr_id = 'numbers_'+str(rewrite_number.id)
	if number != 'any' and len(number) >=10:
		number = phone_number(number)
	if rewrite_to != 'no_rewrite' and len(rewrite_to) >=10:
		rewrite_to = phone_number(rewrite_to)
	strg ='<tr class="rewrite_tr" id='+tr_id+'><td width="40%">'+number+'</td><td width="40%">'+rewrite_to+'</td><td width="20%"><a class="icon-cross" type="button" id='+num_id+' OnClick="RemoveNumber('+str(rewrite_number.id)+')" value="Remove"></a></tr>'
	return HttpResponse(strg)

def RemoveRewriteNumber(request):
	id = request.POST["id"]
	RewriteNumbers.objects.get(id=id).delete()
	print "Number Removed"
	return HttpResponse('ok')	

def RewriteNumber(request):
	if request.method == "POST":
		tree = lambda:collections.defaultdict(tree)
		result_array = tree()

		postdata = request.POST
		accountid = postdata['accountid']
		referer = postdata['referer']

		number_details = RewriteNumbers.objects.filter(assosiated_campaign__rewrite_master__account_id = accountid,assosiated_campaign__rewrite_master__reffering_domain=referer)
		i=0
		for campaign in number_details:
			result_array[i]['word'] = campaign.number
			result_array[i]['change'] = campaign.rewrite_to
			i +=1

		if accountid != '':
			status = 'fine'
			message = 'result_array' 
		else:
			status = 'error'
			message = 'Account id is missing' 
	else:
		status = 'error'
		message = 'GET request is not allowed' 

	return HttpResponse(json.dumps({"status":status,"message":result_array}), content_type='application/json')

def SaveRewrites(request):
	asso_campaigns = request.POST.getlist('assosiated_campaign_ids')
	for assoc in asso_campaigns:
		
		number_clickable = 1
		right_link_text =''
		left_link_text = ''
		if 'rewrite_clickable_'+assoc in request.POST:
			number_clickable = request.POST["rewrite_clickable_"+assoc]
		if 'right_link_text_'+assoc in request.POST:
			right_link_text = request.POST["right_link_text_"+assoc]
		if 'left_link_text_'+assoc in request.POST:
			left_link_text = request.POST["left_link_text_"+assoc]		
		assosiated_campaigns = AssosiatedCampaign.objects.filter(id=assoc).update(number_clickable=number_clickable,left_link_text=left_link_text,right_link_text=right_link_text)
	return redirect('/rewrites/list')	
	# return HttpResponse('ok')

def phone_number(number_param):
	number = number_param[-10:]
	first = number[0:3]
	second = number[3:6]
	third = number[6:10]
	return '(' + first + ')' + ' ' + second + '-' + third