from django.conf.urls import url
from . import views
import os

urlpatterns = [
	url(r'^index/(\d+)/', views.Index, name='index'),
    url(r'^catg-list/', views.CategoryList, name='categorylist'),
    url(r'^ad-groups/',views.Adgroups,name='ad-groups'),
    url(r'^ad-groups-list/',views.AdgroupsList,name='adgroupslist'),
    url(r'^playfiles/',views.Playfiles,name='playfiles'),
    url(r'^addclientcategory/',views.AddCategory),
    url(r'^addadgroup/',views.AddAdgroup),
    url(r'^deleteplayfile/',views.DeletePlayfile),
    url(r'^clienttrans/',views.ClientTrasnfer,name='clienttransfer'),
    url(r'^fetchclients/',views.FetchClients),
    url(r'^transferclients/',views.TransferClients),
    url(r'^updatecountrycodes/',views.UpdateCountryCodes),
    url(r'^trackingdata.js/',views.TrackScriptData),
    url(r'^apisettings/',views.ApiSettings),
]

