from __future__ import unicode_literals

from django.db import models

# Create your models here.

class Login(models.Model):
	name = models.CharField(max_length = 250)
	email = models.CharField(max_length = 250)
	password = models.CharField(max_length = 250)
	status = models.IntegerField()
	previlege = models.IntegerField()
	date_created = models.DateTimeField()
	agency_client_id = models.IntegerField(null=True)

	class Meta:
		db_table = 'user_master'

class Userprofile(models.Model):
	# user_id = models.ForeignKey(Login)
	user_id = models.IntegerField()
	phone_no = models.CharField(max_length = 20)
	street = models.CharField(max_length = 100)
	city = models.CharField(max_length = 100)
	postal_code = models.CharField(max_length = 25)
	country = models.CharField(max_length = 100)
	state = models.CharField(max_length = 100)

	class Meta:
		db_table = 'user_profiles'

class Menu(models.Model):
	name = models.CharField(max_length = 250)
	url = models.CharField(max_length = 250)
	previlege = models.IntegerField()
	status = models.IntegerField()

	class Meta:
		db_table = 'user_menu'


class Industry(models.Model):
	name = models.CharField(max_length = 250)
	status =  models.IntegerField()

	class Meta:
		db_table = 'industry'

class Packages(models.Model):
	package_id = models.AutoField(primary_key=True)
	packagename =  models.CharField(max_length = 250)

	class Meta:
		db_table = 'packages'

class ProfileDetails(models.Model):
	name = models.CharField(max_length = 250)
	url = models.CharField(max_length = 250,null=True)
	industry = models.IntegerField(null=True)
	type_selected = models.IntegerField(null=True)
	address = models.TextField(null=True)
	phone = models.CharField(max_length=25,null=True)
	parent_id = models.IntegerField(null=True)
	status = models.IntegerField()
	sid = models.CharField(max_length = 250,null=True)
	auth_token = models.CharField(max_length = 250,null=True)
	date_created = models.CharField(max_length = 250,null=True)
	date_updated = models.CharField(max_length = 250,null=True)
	individual_business = models.CharField(max_length=250,null=True)
	pricing = models.ForeignKey('settings.Pricing',null=True)
	uniqueid = models.CharField(max_length = 20,null=True)
	package_selected = models.ForeignKey('Packages',null=True)
	class Meta:
		db_table = 'agency_client_details'

