# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models
from decimal import Decimal

# Create your models here.
class CallPricing(models.Model):
    client = models.ForeignKey('userauth.ProfileDetails', on_delete=models.CASCADE) 
    toll_free_number_price = models.DecimalField(max_digits=20,decimal_places=4,default=Decimal('0.0000'))
    toll_free_minutes_price = models.DecimalField(max_digits=20,decimal_places=4,default=Decimal('0.0000'))
    local_number_price = models.DecimalField(max_digits=20,decimal_places=4,default=Decimal('0.0000'))
    local_number_minutes_price = models.DecimalField(max_digits=20,decimal_places=4,default=Decimal('0.0000'))
    byprefix_number_price = models.DecimalField(max_digits=20,decimal_places=4,default=Decimal('0.0000'))
    byprefix_minutes_price = models.DecimalField(max_digits=20,decimal_places=4,default=Decimal('0.0000'))
    class Meta():
    	db_table='call_pricing' 