from django.conf.urls import url
from . import views
import os

urlpatterns = [
    url(r'^settings/', views.Settings, name='settings'),
    url(r'^list/', views.List, name='list'),
    url(r'^campaign-list/', views.CampaignList, name='campaign-list'),
    url(r'^createcampaign/',views.CreateCampaign),
    url(r'^editcampaign/(?P<campaign_id>\d+)/$',views.EditCampaign,name='editcampaign'),
    url(r'^campaignsetting/(?P<campaign_id>\d+)/$',views.CampaignSetting,name='campaignsetting'),
    url(r'^generalsettings/',views.GeneralSettings),
    url(r'^editsettings/',views.EditSettings),
    url(r'^customfields/',views.CustomFieldsList),
    url(r'^addfield/(?P<field_id>\d+)/$',views.AddField,name='addfield'),
    url(r'^updatefield/(?P<field_id>\d+)/$',views.UpdateField,name='editfield'),
    url(r'^deletefield/',views.RemoveField,name='deletefield'),

    url(r'^addtagfield/$',views.AddTagField,name='addtagfield'),
    url(r'^deletetag/$',views.DeleteTag,name='deletetag'),
    url(r'^deletecampaign/', views.DeleteCampaign, name='deletecampaign'),

    # url(r'^playfiles/',views.Playfiles,name='playfileslist'),
    # url(r'^addclientcategory/',views.AddCategory),
    # url(r'^addadgroup/',views.AddAdgroup),
    # url(r'^deleteplayfile/',views.DeletePlayfile),
    # url(r'^clienttrans/',views.ClientTrasnfer,name='clienttransfer'),
    # url(r'^fetchclients/',views.FetchClients),
    # url(r'^transferclients/',views.TransferClients),
    # url(r'^updatecountrycodes/',views.UpdateCountryCodes),

]

