from userauth.models import ProfileDetails

def layoutdropdown(request):

	context = {'mode':''}	
	access = 'yes'
	if request.session.has_key('client_previlege') and request.session.has_key('agency_previlege'):
		agency_id = request.session['parent']
		url_contain = ['view-rewrites', 'edit-user', 'client-call-details', 'updatefield', 'editcampaign']
		for data in url_contain:
			if data in request.path:
				access = 'no'
				break
			else:
				pass
		company_list = ProfileDetails.objects.filter(parent_id=agency_id)
		# user = Login.objects.get(previlege=2,agency_client_id=agency_client_id)
		context = {'list': company_list,'mode':'client','current_client':request.session['client_id'], 'access': access}	

	return {'layoutdropdown':context}

def clientdropdown(request):
	context = {'mode':''}	
	access = 'yes'
	if request.session.has_key('admin_id') and request.session.has_key('agency_previlege') and 'client_previlege' not in request.session:
		agency_id = request.session['agency_id']
		# page_url = ['/userauth/edit-user/','/userauth/edit-client/']
		if 'edit-client' in request.path or 'edit-user' in request.path:
			access = 'no'

		company_list = ProfileDetails.objects.filter(parent_id=0, status = 1)
		context = {'list': company_list,'mode':'agency','current_agency':request.session['agency_id'], 'access': access}

	return {'clientdropdown':context}

def datefilter(request):
	access = 'no'
	mode = ''
	context = {'mode':mode,'access': access}	
	if request.session.has_key('admin_id') and 'agency_previlege' not in request.session and 'client_previlege' not in request.session:
		mode ='admin'
	elif request.session.has_key('agency_id') and 'client_previlege' not in request.session and 'client_previlege' not in request.session:
		mode = 'agency'
		page_url = ['/calls/agency-dashboard/','/calls/account-data-list/']
		if request.path in page_url:
			access = 'yes'		
	else:
		mode = 'client'
		page_url = ['/calls/client-dashboard/','/calls/call-logs/','/numbers/list-numbers/']
		if request.path in page_url:
			access = 'yes'
		# if '/calls/client-call-details/' in request.path:
		# 	access = 'yes'

	context = {'mode': mode, 'access': access}

	return {'datefilter':context}






