from django.conf.urls import url
from . import views

urlpatterns = [
	url(r'^agency-list/', views.AgencyList, name = 'agency-list'),
    url(r'^sign-up/', views.SignUp, name = 'sign-up'),
    url(r'^edit-profile/', views.EditProfile, name = 'edit-profile'),
    # url(r'^layout-test/', views.SideMenu, name = 'SideMenu'),
    url(r'^$', views.login, name='login'),
    url(r'^login/', views.login, name = 'login'),
    # url(r'^logout/(\d+)/', views.logout, name = 'logout'),
    url(r'^logout/', views.logout, name = 'logout'),
    url(r'^autologin/(\d+)/', views.AutoLogin, name = 'autologin'),
    url(r'^autologin-client/(\d+)/', views.AutoLoginClient, name = 'autologin-client'),    
    url(r'^remove-agency/(\d+)/', views.RemoveAgency, name = 'remove-agency'),
    # url(r'^reset-password/(\w+)/', views.ResetPassword, name = 'reset-password'),
    url(r'^reset-password/(?P<key>.*)/', views.ResetPassword, name = 'reset-password'),
    url(r'^add-client/', views.AddClient, name = 'add-client'),
    url(r'^add-agency/', views.AddAgency, name = 'add-agency'),
    url(r'^editagency/(\d+)', views.EditAgency, name = 'editagency'),
    url(r'^forgotpassword/', views.Forgotpassword, name = 'forgotpassword'),
    url(r'^check-profile/', views.CheckProfile, name = 'check-profile'),
    url(r'^save-client/', views.SaveClient, name = 'save-client'),
    url(r'^client-list/', views.ClientList, name = 'client-list'),
    url(r'^edit-client/(\d+)', views.EditClient, name = 'edit-client'),
    url(r'^user-list/', views.UserList, name = 'user-list'),
    url(r'^user-list-data/', views.UserListData, name = 'user-list-data'),
    url(r'^add-user/', views.AddUser, name = 'add-user'),
    url(r'^save-user/', views.SaveUser, name = 'save-user'),
    url(r'^edit-user/$', views.EditUser, name = 'edit-user'),
    url(r'^back-to-superadmin/$', views.BackToSuperAdmin, name = 'back-to-superadmin'),
    url(r'^back-to-agency/$', views.BackToAgency, name = 'back-to-agency'),
    url(r'^ga-login/(?P<key1>.*)/(?P<key2>.*)/$', views.GaLogin, name = 'ga-login'),
    url(r'^check-permission/', views.CheckPermission1, name = 'check-permission'),
    url(r'^transfer-clients/', views.TransferClients, name = 'transfer-clients'),
    url(r'^get-clients/', views.GetClients, name = 'get-clients'),
    url(r'^update-clients/', views.UpdateClients, name = 'update-clients'),
    url(r'^reset-password/', views.ResetPasswordErr, name = 'reset-password-err'),
    url(r'^clientlist-demo/', views.ClientListDEMO, name = 'reset-password-err'),
    url(r'^manipulate-number/', views.ManipulatingPhoneNumber, name = 'manipulate-number'),
 ]